﻿;
; Software: FX Configurator
;
; Creater: alanfox2000
; 
; Info: https://www.techpowerup.com/forums/threads/the-ultimate-realtek-hd-audio-driver-mod-for-windows-10.232921
;
; Date: 8/3/2018
;
; Version: 1.0.0.1
;
#NoEnv
#SingleInstance Force
; If the script is not elevated, relaunch as administrator and kill current instance:

full_command_line := DllCall("GetCommandLine", "str")

if not (A_IsAdmin or RegExMatch(full_command_line, " /restart(?!\S)"))
{
    try ; leads to having the script re-launching itself as administrator
    {
        if A_IsCompiled
            Run *RunAs "%A_ScriptFullPath%" /restart
        else
            Run *RunAs "%A_AhkPath%" /restart "%A_ScriptFullPath%"
    }
    ExitApp
}

SetWorkingDir %A_ScriptDir%
PresetFolder = %A_WorkingDir%\Preset
RenderPath = HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\MMDevices\Audio\Render
CapturePath = HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\MMDevices\Audio\Capture
ConnectorSubKey = {a45c254e-df1c-4efd-8020-67d146a850e0},2
DeviceSubKey = {b3f8fa53-0004-438e-9003-51a46e139bfc},6 
LFXSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},1
GFXSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},2
SFXSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},5
MFXSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},6
EFXSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},7
UISubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},3
FriendlyNameSubKey = {d04e05a6-594b-4fb6-a80d-01af5eed7d1d},4
SoftwareName = FX Configurator
SoftwareVersion = 1.0.0.1
regjump = %A_WorkingDir%\regjump.exe
StartFile = %A_WorkingDir%\Start.bat
StopFile = %A_WorkingDir%\Stop.bat
RestartFile = %A_WorkingDir%\Restart.bat
StartContent = 
(
@echo off
sc start audiosrv
exit
)
StopContent = 
(
@echo off
sc stop audiosrv
exit
)
RestartContent = 
(
@echo off
sc stop audiosrv
sc start audiosrv
exit
)

If (A_Is64bitOS)
{
 ACLBit=64
 Bit=64
}
Else
{
 ACLBit=32
 Bit=
}

Console = %A_WorkingDir%\ConEmuPack\ConEmu%Bit%.exe  -Min /cmd cmd.exe -new_console:n /c

Loop %PresetFolder%\*.ini
{
 Presetfiles .= (( Presetfiles <> "" ) ? "|" : "" ) A_LoopFileName
}

Gui Add, Text, x11 y10 w579 h21, Please select the devices for which the APO is to be installed:
Gui Add, Text, x24 y296 w86 h23 +0x200, LFX :
Gui Add, Text, x24 y328 w86 h23 +0x200, GFX :
Gui Add, Text, x24 y360 w86 h23 +0x200, SFX :
Gui Add, Text, x24 y392 w86 h23 +0x200, MFX :
Gui Add, Text, x24 y424 w87 h23 +0x200, EFX :
Gui Add, Text, x24 y456 w89 h23 +0x200, UI :
Gui Add, Text, x24 y488 w90 h23 +0x200, Friendly Name :
Gui Add, Edit, x120 y296 w270 h21 vLFX
Gui Add, Edit, x120 y328 w270 h21 vGFX
Gui Add, Edit, x120 y360 w270 h21 vSFX
Gui Add, Edit, x120 y392 w270 h21 vMFX
Gui Add, Edit, x120 y424 w270 h21 vEFX
Gui Add, Edit, x120 y456 w270 h21 vUI
Gui Add, Edit, x120 y488 w270 h21 vFriendlyName
Gui Add, GroupBox, x16 y528 w100 h97, Audio Services
Gui Add, Button, x24 y544 w80 h23 gRestart, Restart
Gui Add, Button, x24 y568 w80 h23 gStop, Stop
Gui Add, Button, x24 y592 w80 h23 gStart, Start
Gui Add, Button, x272 y536 w80 h23 gApply, Apply
Gui Add, Button, x168 y576 w80 h23 gRefresh, Refresh
Gui Add, Button, x272 y576 w80 h23 gClear, Clear
Gui Add, Button, x168 y536 w80 h23 gOregedit, Open Regedit
Gui Add, GroupBox, x400 y288 w216 h334, Presets
Gui Add, ListBox, x416 y312 w188 h208 vSelectedPreset, %Presetfiles%
Gui Add, Button, x424 y536 w173 h23 gLoad, &Load
Gui Add, Button, x424 y568 w173 h35 gAPOExternalData, &Add external data to selected devices from selected preset

Gui Add, Tab3, x16 y32 w584 h249, Playback devices|Capture devices
Gui Tab, 1
Gui Add, ListView, x16 y56 w576 h219 AltSubmit gRenderListView vRenderList, Connector|Device|GUID
Gui Tab, 2
Gui Add, ListView, x16 y56 w576 h219 AltSubmit gCaptureListView vCaptureList, Connector|Device|GUID
gosub, Refresh
Gui, Preset:-MinimizeBox -MaximizeBox
Gui Show, w631 h631, %SoftwareName% %SoftwareVersion%
Return

Refresh:
Gui, ListView, RenderList
LV_Delete()
Loop, Reg, %RenderPath%, K
{
Render_GUID = %A_LoopRegName%
RegRead, Connector, %RenderPath%\%Render_GUID%\Properties, %ConnectorSubKey%
RegRead, Device, %RenderPath%\%Render_GUID%\Properties, %DeviceSubKey%
LV_Add("", Connector, Device, Render_GUID)
LV_ModifyCol()  
}
Gui, ListView, CaptureList
LV_Delete()
Loop, Reg, %CapturePath%, K
{
Capture_GUID = %A_LoopRegName%
RegRead, Connector, %CapturePath%\%Capture_GUID%\Properties, %ConnectorSubKey%
RegRead, Device, %CapturePath%\%Capture_GUID%\Properties, %DeviceSubKey%
LV_Add("", Connector, Device, Capture_GUID)
LV_ModifyCol()  
}
Gui, Submit, NoHide
Return


RenderListView:
Gui, ListView, RenderList
RowNumber = 0
Loop
{
RowNumber := LV_GetNext(RowNumber)
if not RowNumber
    break
Type = Render
LV_GetText(Selected_GUID, RowNumber, 3)
RegRead, LFX, %RenderPath%\%Selected_GUID%\FxProperties, %LFXSubKey%
RegRead, GFX, %RenderPath%\%Selected_GUID%\FxProperties, %GFXSubKey%
RegRead, SFX, %RenderPath%\%Selected_GUID%\FxProperties, %SFXSubKey%
RegRead, MFX, %RenderPath%\%Selected_GUID%\FxProperties, %MFXSubKey%
RegRead, EFX, %RenderPath%\%Selected_GUID%\FxProperties, %EFXSubKey%
RegRead, UI, %RenderPath%\%Selected_GUID%\FxProperties, %UISubKey%
RegRead, FriendlyName, %RenderPath%\%Selected_GUID%\FxProperties, %FriendlyNameSubKey%
GuiControl,, LFX, %LFX%
GuiControl,, GFX, %GFX%
GuiControl,, SFX, %SFX%
GuiControl,, MFX, %MFX%
GuiControl,, EFX, %EFX%
GuiControl,, UI, %UI%
GuiControl,, FriendlyName, %FriendlyName%
}
return


CaptureListView:
Gui, ListView, CaptureList
RowNumber = 0
Loop
{
RowNumber := LV_GetNext(RowNumber)
if not RowNumber
    break
Type = Capture
LV_GetText(Selected_GUID, RowNumber, 3)
RegRead, LFX, %CapturePath%\%Selected_GUID%\FxProperties, %LFXSubKey%
RegRead, GFX, %CapturePath%\%Selected_GUID%\FxProperties, %GFXSubKey%
RegRead, SFX, %CapturePath%\%Selected_GUID%\FxProperties, %SFXSubKey%
RegRead, MFX, %CapturePath%\%Selected_GUID%\FxProperties, %MFXSubKey%
RegRead, EFX, %CapturePath%\%Selected_GUID%\FxProperties, %EFXSubKey%
RegRead, UI, %RenderPath%\%Selected_GUID%\FxProperties, %UISubKey%
RegRead, FriendlyName, %CapturePath%\%Selected_GUID%\FxProperties, %FriendlyNameSubKey%
GuiControl,, LFX, %LFX%
GuiControl,, GFX, %GFX%
GuiControl,, SFX, %SFX%
GuiControl,, MFX, %MFX%
GuiControl,, EFX, %EFX%
GuiControl,, UI, %UI%
GuiControl,, FriendlyName, %FriendlyName%
}
return

Apply:
gosub GetSelectedDevice
GuiControlGet, LFX
GuiControlGet, GFX
GuiControlGet, SFX
GuiControlGet, MFX
GuiControlGet, EFX
GuiControlGet, UI
GuiControlGet, FriendlyName
gosub, RegistryPermissions
If (LFX = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %LFXSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %LFXSubKey%, %LFX%
}
If (GFX = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %GFXSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %GFXSubKey%, %GFX%
}
If (SFX = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %SFXSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %SFXSubKey%, %SFX%
}
If (MFX = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %MFXSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %MFXSubKey%, %MFX%
}
If (EFX = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %EFXSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %EFXSubKey%, %EFX%
}
If (UI = "") {
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %UISubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %UISubKey%, %UI%
}
If (FriendlyName = "")
{
RegDelete, %RedirectPath%\%Selected_GUID%\FxProperties, %FriendlyNameSubKey%
}
ELSE {
RegWrite, REG_SZ, %RedirectPath%\%Selected_GUID%\FxProperties, %FriendlyNameSubKey%, %FriendlyName%
}
return

RegistryPermissions:
PermissionsContent = 
(
@echo off
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%" -ot reg -actn setowner -ownr "n:Administrators"
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%" -ot reg -actn ace -ace "n:Administrators;p:full"
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%\FxProperties" -ot reg -actn setowner -ownr "n:Administrators"
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%\FxProperties" -ot reg -actn ace -ace "n:Administrators;p:full"
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%\Properties" -ot reg -actn setowner -ownr "n:Administrators"
SetACL%ACLBit%.exe -on "%RedirectPath%\%Selected_GUID%\Properties" -ot reg -actn ace -ace "n:Administrators;p:full"
exit
)
PermissionsFile = %A_WorkingDir%\Permissions.bat
FileDelete, %PermissionsFile%
FileAppend, %PermissionsContent%, %PermissionsFile%
runwait, %Console% "%PermissionsFile%"
FileDelete, %PermissionsFile%
Return

Load:
GuiControlGet, SelectedPreset
SelectedPresetFullPath = %PresetFolder%\%SelectedPreset%
IniRead, LFX, %SelectedPresetFullPath%, FXConfiguration, LFX
IniRead, GFX, %SelectedPresetFullPath%, FXConfiguration, GFX
IniRead, SFX, %SelectedPresetFullPath%, FXConfiguration, SFX
IniRead, MFX, %SelectedPresetFullPath%, FXConfiguration, MFX
IniRead, EFX, %SelectedPresetFullPath%, FXConfiguration, EFX
IniRead, UI, %SelectedPresetFullPath%, FXConfiguration, UI
IniRead, FriendlyName, %SelectedPresetFullPath%, FXConfiguration, FriendlyName
GuiControl, , LFX, %LFX%
GuiControl, , GFX, %GFX%
GuiControl, , SFX, %SFX%
GuiControl, , MFX, %MFX%
GuiControl, , EFX, %EFX%
GuiControl, , UI, %UI%
GuiControl, , FriendlyName, %FriendlyName%
Gui, Submit, Nohide
Return

GuiPreset:
Gui, Preset:-MinimizeBox -MaximizeBox
Gui, Preset:Show, w216 h297, Preset
Return

Restart:
FileDelete, %RestartFile%
FileAppend, %RestartContent%, %RestartFile%
runwait, %Console% "%RestartFile%"
FileDelete, %RestartFile%
Return

Stop:
FileDelete, %StopFile%
FileAppend, %StopContent%, %StopFile%
runwait, %Console% "%StopFile%"
FileDelete, %StopFile%
Return

Start:
FileDelete, %StartFile%
FileAppend, %StartContent%, %StartFile%
runwait, %Console% "%StartFile%"
FileDelete, %StartFile%
Return

PresetClose:
GUI, Preset:Hide
Return

APOExternalData:
gosub, GetSelectedDevice
GuiControlGet, SelectedPreset
SelectedPresetFullPath = %PresetFolder%\%SelectedPreset%
IniRead, NumOfData, %SelectedPresetFullPath%, FXConfiguration, NumOfData
If (NumOfData = "" OR NumOfData = "0")
    return
gosub, RegistryPermissions
Loop, %NumOfData%
{
IniRead, Data_Type, %SelectedPresetFullPath%, Data%A_index%, Type
IniRead, Data_Key, %SelectedPresetFullPath%, Data%A_index%, Key
IniRead, Data_ValueName, %SelectedPresetFullPath%, Data%A_index%, ValueName
IniRead, Data_Value, %SelectedPresetFullPath%, Data%A_index%, Value
RegWrite, %Data_Type%, %RedirectPath%\%Selected_GUID%\%Data_Key%, %Data_ValueName%, %Data_Value%
}
return

GetSelectedDevice:
if Type = Render
{
    Gui, ListView, RenderList
    RedirectPath = %RenderPath%
}
if Type = Capture
{
    Gui, ListView, CaptureList
    RedirectPath = %CapturePath%
}
RowNumber = 0
RowNumber := LV_GetNext(RowNumber)
if not RowNumber
{
    msgbox, Please select a device
    exit
}
return

Clear:
GuiControl, , LFX,
GuiControl, , GFX,
GuiControl, , SFX,
GuiControl, , MFX,
GuiControl, , EFX,
GuiControl, , UI,
GuiControl, , FriendlyName,
return

Oregedit:
gosub GetSelectedDevice
run, %regjump% "%RedirectPath%\%Selected_GUID%"
WinRestore, ahk_class RegEdit_RegEdit
return

GuiEscape:
GuiClose:
    ExitApp